var gForm;
var insertNew;
var formElement;
var formActionWarning;

function Startup()
{
  if (!InitEditorShell())
    return;

  gForm = {
    Name:     document.getElementById( "FormName" ),
    Action:   document.getElementById( "FormAction" ),
    Method:   document.getElementById( "FormMethod" ),
    EncType:  document.getElementById( "FormEncType" ),
    Target:   document.getElementById( "FormTarget" )
  }
  gDialog.MoreSection = document.getElementById( "MoreSection" );
  gDialog.MoreFewerButton = document.getElementById( "MoreFewerButton" );

  // Get a single selected form element
  var tagName = "form";
  formElement = editorShell.GetElementOrParentByTagName(tagName, editorShell.editorSelection.anchorNode);
  if (!formElement)
    formElement = editorShell.GetElementOrParentByTagName(tagName, editorShell.editorSelection.focusNode);

  if (formElement)
  {
    // We found an element and don't need to insert one
    insertNew = false;
    formActionWarning = formElement.hasAttribute("action");
  }
  else
  {
    insertNew = true;
    formActionWarning = true;

    // We don't have an element selected,
    //  so create one with default attributes

    formElement = editorShell.CreateElementWithDefaults(tagName);
    if( !formElement )
    {
      dump("Failed to get selected element or create a new one!\n");
      window.close();
      return;
    }
  }

  // Make a copy to use for AdvancedEdit
  globalElement = formElement.cloneNode(false);

  InitDialog();

  InitMoreFewer();

  SetTextboxFocus(gForm.Name);

  SetWindowLocation();
}

function InitDialog() {
  for (var attribute in gForm)
    gForm[attribute].value = globalElement.getAttribute(attribute);
}

function ValidateData() {
  if (formActionWarning && !gForm.Action.value) {
    AlertWithTitle(GetString("Alert"), GetString("NoFormAction"));
    gForm.Action.focus();
    formActionWarning = false;
    return false;
  }
  for (var attribute in gForm) {
    if (gForm[attribute].value)
      globalElement.setAttribute(attribute, gForm[attribute].value);
    else
      globalElement.removeAttribute(attribute);
  }
  return true;
}

function onOK() {
  if (ValidateData()) {
    // All values are valid - copy to actual element in doc or
    //   element created to insert

    editorShell.CloneAttributes(formElement, globalElement);

    if (insertNew)
      InsertBlockAroundSelection(formElement);
  
    SaveWindowLocation();
  
    return true;
  }
  return false;
}
